// stuff for timer

long m = System.currentTimeMillis();
long lastcheck = System.currentTimeMillis();
int interval = 60000; // write log file once per minute

// stuff for log file

FileWriter dataFile;
String fileName;
String writeData;
long fileNameTimer = System.currentTimeMillis();
long fileNameChangeInterval = 10 * 60 * 60 * 1000;// new log file every 10 hours
boolean logStarted = false;

// stuff for closing then opening file

long fileCloseOpenTimer= System.currentTimeMillis();
int fileCloseOpenInterval = 60 * 60000;



boolean checkTimer() {

    m = System.currentTimeMillis();
    if ((m - lastcheck) > interval) {
        lastcheck = m;
        return true; 
    } 
    else { 
        return false; 
    }
}






void writeLogFile(String newData){

    if (((System.currentTimeMillis() - fileNameTimer) > fileNameChangeInterval) | (logStarted == false)) {
        restartFile();
    }

    if (((System.currentTimeMillis() - fileCloseOpenTimer) > fileCloseOpenInterval) & (logStarted)) {
        closeOpenFile();
    }

    newData = str(System.currentTimeMillis()) + ": " + newData;
    try {
        dataFile.write(newData + "\n", 0, newData.length()+1); //(string, start char, end char) 
    }  
    catch(Exception e)  
    {  
        println("Error: Can't open file! " + e); 
    }
    //println("new data in log file");

}



void closeOpenFile(){


    try {
        dataFile.close();
        dataFile = new FileWriter(fileName, true); //bool tells to append 
    }  
    catch(Exception e)  
    {  
        println("Error: Can't open file! " + e); 
    } 

    fileCloseOpenTimer = System.currentTimeMillis();

    println("closed and opened file");

     
}


void restartFile(){

    if (logStarted){
        try { 
            dataFile.close(); 
            println("closing old log");
        }  
        catch(Exception e) { 
            println("Error: Can't open file! " + e); 
        } 
    }

    fileName = str(year()) + "-" + str(month()) + "-" + str(day()) + "-" + str(hour()) + "-" + str(minute()) + "-" + str(second()) + "-data.txt";

    try {
        dataFile = new FileWriter(fileName, true); //bool tells to append 
    }  
    catch(Exception e)  
    {  
        println("Error: Can't open file! " + e); 
    } 

    fileNameTimer = System.currentTimeMillis();
    logStarted = true;
    println("started new log file");
    
    String logTemp = "\nSensors";
      
    for (int i = 0; i < totalSensors; i++){
      
       logTemp += i + ": " + sensorName[i] + ", ";
       
     }
      logTemp += "\n";
    for (int i = 0; i < totalActuators; i++){
      
       logTemp += i + ": " + actuatorName[i] + ", ";
       
     }
      logTemp += "\n";
     writeLogFile(logTemp);  
     

}



