//TODO
/*

 grey out also should be dark
 
 dragOver effect
 
 draw connections, also on/off interface for this.
 
 connectMostPopular();
 
 Adam's Office
 
 Usman's Office
 
 */
//



// ---------------------[ UI init ]------------------------- 
import damkjer.ocd.*;
import processing.opengl.*;
import javax.media.opengl.*; 
Camera camera1;

color selectedPixel; 

// is sensor, is actuator, colorHue 
int[] cat1 = { 
    1, 1, 40 };
int[] cat2 = { 
    0, 1, 45 };
int[] lili2 = { 
    1, 1, 20 };
int[] lili1 = { 
    1, 1, 25 };
int[] penguin1 = { 
    0, 1, 95};
int[] penguin2 = { 
    0, 1, 90};
int[] mist1 = { 
    1, 0, 60};
int[] mist2 = { 
    1, 0, 65};
int[] mp3 = { 
    1, 1, 50 };
int[] sqrl = {
    0, 0, 10 };
int[] monkey = {
    1, 0, 2 };    

int[] mood = {
    1, 0, 70 };    
int[] panic = {
    0, 0, 80};
int[] phone = {
    1, 0, 30};

        

// background colors
int backHueOk = 33;
int backHueError = 97;
int backHuePanic = 75;
int backHue = 0;
int backBright = 0;


// textures
PImage phoneTexture;
PImage mp3Texture;


// each column has: name, issensor, isactuator, colorHue, var5, var6, linkedto1, linkedto2, ...
// 20 stands fo2 the amount of devices, height is + 6.
String[][] devices = new String[20][26];


String selectedSensor;
String selectedActuator;
String selectedDevice;

//fingerConnects(whatAct, whatSen);

// total 

PFont iccFont;
PImage icons2D;

boolean fingerOverSensor = false;
boolean fingerOverActuator = false;
boolean fingerRotating = false;
float camSpinSpeed;
int fingerPlacedX;
int fingerPlacedY;
int fingerRelseasedX;
int fingerRelseasedY;
String releaseMessage;
int releaseDelay;

// ---------------------[ / UI init ]------------------------- 






void UISetup(){
    camera1 = new Camera(this, 400, -170, 300, 0, -180, 0);
    iccFont = loadFont("Krungthep-48.vlw"); 

    icons2D = loadImage("panic.png");
    
    phoneTexture = loadImage("phone.png");
    mp3Texture = loadImage("mp3.png");


}





void drawUI(){
    background(backHue, 100, backBright);

    if (backBright != 0) backBright -= 15;


    // 3D
    camera1.feed();
    

    drawFrame();
    
    drawConnections();
    
    
    drawPenguins();
    drawLilies();
    drawCats();
    drawSquirrels();
    drawMist();
    drawMonkey();
    drawHandle();
    drawMP3();
    drawPhone();
    
    // 2D
    draw2D();


    if (!fingerOverSensor && !fingerOverActuator) rotateView();
    if (fingerOverSensor || fingerOverActuator) {
        if (mousePressed) drawConnection();

    } 

}


// ---------------------[ Finger Actions ]------------------------- 
void mousePressed(){
    fingerPlacedX = mouseX;
    fingerPlacedY = mouseY;
    //noCursor();

    if (getFingerPixelSat(fingerPlacedX, fingerPlacedY) > 10) {

        float deviceHue = getFingerPixelHue(fingerPlacedX, fingerPlacedY);
        selectedDevice = dispathColors(deviceHue);

        // panic
        if (selectedDevice == "panic") {
            //println("error, try again");
            fingerOverSensor = false;
            fingerOverActuator = false;
            fingerRotating = false; 
            backHue = backHuePanic;
            backBright = 100;
            resetConnections();
        } 
        else if (checkIfSensorActuator(selectedDevice, 0) == 1){
            fingerRotating = false;
            fingerOverSensor = true;
            fingerOverActuator = false;
            selectedSensor = selectedDevice;

        } 
        else  if (checkIfSensorActuator(selectedDevice, 1) == 1) {
            fingerOverSensor = false;
            fingerOverActuator = true;
            fingerRotating = false; 
            selectedActuator = selectedDevice;
        }
    } 
    else {
        fingerOverSensor = false;
        fingerOverActuator = false;
        fingerRotating = true;   
    }
}

void mouseDragged() {
    if (fingerRotating) camSpinSpeed = - radians(mouseX - pmouseX) / 3;
    if (!fingerRotating) drawConnection();
    stopBeingBored();
}

void mouseReleased(){
    cursor(ARROW);
    if (!fingerRotating && getFingerPixelSat(mouseX, mouseY) > 10) {
        float deviceHue = getFingerPixelHue(mouseX, mouseY);

        // panic
        if (selectedDevice == "panic") {
            println("panic");
            fingerOverSensor = false;
            fingerOverActuator = false;
            fingerRotating = false; 
            backHue = backHuePanic;
            //resetConnections();
            //backBright = 100;
        } 
        else if (fingerOverSensor) {
            selectedActuator = dispathColors(deviceHue);
            if (runTime) fingerConnects((selectedActuator + "Act"), (selectedSensor + "Sen"));
            println("fingerConnects(" + selectedActuator + "Act, " + selectedSensor + "Sen");
            backHue = backHueOk;
            backBright = 100;

            fingerRelseasedX = mouseX;
            fingerRelseasedY = mouseY;
            releaseMessage = "Actuator \n" + selectedActuator;
            releaseDelay = 100;

        } 
        else if (fingerOverActuator){
            selectedSensor = dispathColors(deviceHue);
            if (runTime) fingerConnects((selectedActuator + "Act"), (selectedSensor + "Sen"));
            println("fingerConnects(" + selectedActuator + "Act, " + selectedSensor + "Sen");
            backHue = backHueOk;
            backBright = 100;

            fingerRelseasedX = mouseX;
            fingerRelseasedY = mouseY;
            releaseMessage = "Sensor \n" + selectedSensor;
            releaseDelay = 100;

        }

    }
    else if(!fingerRotating) {
        backHue = backHueError;
        backBright = 100;
        fingerRelseasedX = 250;
        fingerRelseasedY = 400;
        releaseMessage = "ERROR, please try again! \n(please select colors)";
        releaseDelay = 100;
        //println("false");
    }
    fingerRotating = false;
    fingerOverSensor = false;
    fingerOverActuator = false;


}




String dispathColors(float colorHue){
    float colorRange = 3;
    String foundColor = "empty";

    if ( (colorHue - cat1[2]) < colorRange && (colorHue - cat1[2]) > - colorRange ) foundColor = "cat1"; 
    if ( (colorHue - cat2[2]) < colorRange && (colorHue - cat2[2]) > - colorRange ) foundColor = "cat2"; 
    if ( (colorHue - lili1[2]) < colorRange && (colorHue - lili1[2]) > - colorRange ) foundColor = "lili1"; 
    if ( (colorHue - lili2[2]) < colorRange && (colorHue - lili2[2]) > - colorRange ) foundColor = "lili2"; 
    if ( (colorHue - penguin1[2]) < colorRange && (colorHue - penguin1[2]) > - colorRange ) foundColor = "penguin1"; 
    if ( (colorHue - penguin2[2]) < colorRange && (colorHue - penguin2[2]) > - colorRange ) foundColor = "penguin2"; 
    if ( (colorHue - mist1[2]) < colorRange && (colorHue - mist1[2]) > - colorRange ) foundColor = "mist1"; 
    if ( (colorHue - mist2[2]) < colorRange && (colorHue - mist2[2]) > - colorRange ) foundColor = "mist2"; 
    if ( (colorHue - sqrl[2]) < colorRange && (colorHue - sqrl[2]) > - colorRange ) foundColor = "sqrl"; 
    if ( (colorHue - monkey[2]) < colorRange && (colorHue - monkey[2]) > - colorRange ) foundColor = "monkey"; 
    if ( (colorHue - mp3[2]) < colorRange && (colorHue - mp3[2]) > - colorRange ) foundColor = "mp3"; 
    if ( (colorHue - panic[2]) < colorRange && (colorHue - panic[2]) > - colorRange ) foundColor = "panic"; 
    if ( (colorHue - mood[2]) < colorRange && (colorHue - mood[2]) > - colorRange ) foundColor = "mood"; 
    if ( (colorHue - phone[2]) < colorRange && (colorHue - phone[2]) > - colorRange ) foundColor = "phone"; 

    return foundColor;
}


// needs deviceName, checkWhat 0 for sensor 1 for actuator, returns 0 if not, 1 if yes
int checkIfSensorActuator(String deviceName, int checkWhat){
    float colorRange = 3;
    int answer = 3;

    if (deviceName.equals("cat1")) answer = cat1[checkWhat];
    if (deviceName.equals("cat2")) answer = cat2[checkWhat];
    if (deviceName.equals("lili1")) answer = lili1[checkWhat];
    if (deviceName.equals("lili2")) answer = lili2[checkWhat];
    if (deviceName.equals("penguin1")) answer = penguin1[checkWhat];
    if (deviceName.equals("penguin2")) answer = penguin2[checkWhat];
    if (deviceName.equals("mist1")) answer = mist1[checkWhat];
    if (deviceName.equals("mist2")) answer = mist2[checkWhat];
    if (deviceName.equals("sqrl")) answer = sqrl[checkWhat];
    if (deviceName.equals("monkey")) answer = monkey[checkWhat];
    if (deviceName.equals("mp3")) answer = mp3[checkWhat];
    if (deviceName.equals("panic")) answer = panic[checkWhat];
    if (deviceName.equals("mood")) answer = mood[checkWhat];
    if (deviceName.equals("phone")) answer = phone[checkWhat];

    return answer;
}

float getFingerPixelSat(int fingerX, int fingerY){
    turn3DOff();
    loadPixels();
    selectedPixel = pixels[mouseY * width + mouseX];
    turn3DOn();
    return(saturation(selectedPixel));
}

float getFingerPixelHue(int fingerX, int fingerY){
    turn3DOff();
    loadPixels();
    selectedPixel = pixels[mouseY * width + mouseX];
    turn3DOn();
    return(hue(selectedPixel));
}



// ---------------------[ 2D UI ]------------------------- 
void drawConnection(){
    turn3DOff();
    int horizontal;
    int vertical;
    if (mouseX > fingerPlacedX) {
        horizontal = -1;
    } 
    else {
        horizontal = 1;
    } 
    if (mouseY > fingerPlacedY) {
        vertical = -1;
    } 
    else {
        vertical = 1;
    }
    textFont(iccFont, 48); 
    for (int i=0; i<100; i++){
        stroke(random(100), 100, 100, 20);
        if (fingerOverSensor) {
            line(fingerPlacedX , fingerPlacedY , mouseX + (25 * horizontal) + random(50)-25, mouseY  + (25 * vertical) + random(50) - 25);

        }
        if (fingerOverActuator) {
            line(fingerPlacedX + random(50)-25, fingerPlacedY + random(50)-25, mouseX + (5 * horizontal), mouseY  + (5 * vertical));

        }
    }
    String s = "";
    if (fingerOverSensor) s = "Sensor\n" + selectedDevice;
    if (fingerOverActuator) s = "Actuator\n" + selectedDevice;
    fill(0, 0, 0, 100);
    text(s, fingerPlacedX + 12, fingerPlacedY + 2);
    fill(0, 0, 100);
    text(s, fingerPlacedX + 10, fingerPlacedY);

    noFill();
    strokeWeight(3);
    stroke(100);
    ellipseMode(CENTER);
    ellipse(mouseX, mouseY, 40, 40);
    ellipseMode(CORNER);
    strokeWeight(1);
    turn3DOn();
}


// ---------------------[ 3D ]------------------------- 
void rotateView(){
    camera1.circle(camSpinSpeed);
    camSpinSpeed /= 1.18;
}

void turn3DOff(){
    GL gl= ((PGraphicsOpenGL)g).gl;
    gl.glDepthFunc(javax.media.opengl.GL.GL_ALWAYS); //turn off Z buffering
    camera(); //reset the camera
}

void turn3DOn(){
    GL gl= ((PGraphicsOpenGL)g).gl;
    gl.glDepthFunc(javax.media.opengl.GL.GL_LESS); //turn it back on
}
